/* 
 * CSE142, 98 Autumn
 * Homework 4
 * Andrea Nelson  
 * ID: 9722274
 * Sec: AC
 * Rain Gods and Goddesses
 */

#include "gp142.h"
#include <stdio.h>
#include <math.h>

#include <time.h>

#define TRUE    		1
#define FALSE   		0

/* Configure the appearance of the buttons on the menu bar */
/*number of pixels of button height and width*/
#define BUTTON_HEIGHT  	56
#define BUTTON_WIDTH 	100

/*change this if you add or delete buttons*/
#define NUM_BUTTONS 	8

/*color of letter on buttons*/
#define SELECTED_COLOR   YELLOW	 
#define UNSELECTED_COLOW BLACK

/*total amount of drops at one time */
#define MAX_PRECIP_EVENTS	500
	
/* y-ccordinate of the top of the "dirt" in the landscape*/
#define TOP_OF_DIRT (- 2 * (GP142_YMAX / 5))


/* For many of the GP142 functions, a line width of
 * zero means to fill the shape being drawn.
 */
#define FILL 0

/* Types of precipitations we support */
#define NONE 0
#define RAIN 1
#define SNOW 2
#define HAIL 3

/*largest amount of precipitation types*/
#define MAX_PRECIP_TYPES 3

/*Possible places for mouse clicks*/
#define BUTTON 1
	
#define DIRT 2
	

/*******************  FUNCTION PROTOTYPES **************************/

	/*redraw all the buttons.
	The parameters tell which button should be highlighted
	*/
void DrawButtons(int current_precip, int current_color, int *current_landscape);

/*Clear all percipitation, so the landscape is just as originally*/
void ClearAllPrecipitation(int *precip_type,int max, int *clouds, 
							int *lightning, int *sky, int *drops, int *color);


/*render (draw) all the precipitation*/
void DrawAllPrecipitation(int *type, int *x, int *y, 
		 int *color, int n);

void DrawLandscape();

void DrawClouds(int clouds, int current);

/*add a drop*/
int addpoint(int x, int y, int color, int precip, int n, 
			  int bottom_x[], int bottom_y[], int precip_color[],
			  int precip_type[]);
/*draw one drop*/
void DrawPrecipColumn(int precip_type, int bottom_x, int bottom_y, int color);

void DrawRainDrop (int x, int y, int color);
void DrawSnowDrop (int x, int y, int color);
void DrawHailDrop (int x, int y, int color);

/*Return an integer which tells what KIND of click there was */
int  ClassifyMouseClick(int mouse_x, int mouse_y);

/*Given that a button was click, call an appropriate function to handle it*/
void handle_button(int x, int y, int *current_precip, int *current_color,
		   int *replant, int *clouds, int *sky);

/*****************************************************************************

     MAIN

*****************************************************************************/

int main(void)
{
  int quit = FALSE;
  int mouse_x, mouse_y;
  char key_hit;

  int sun_x =GP142_XMAX - 50, sun_y = GP142_YMAX - 35;

  /* 
   * The next itens tell what weather is happening, 
   its "leading edge" or bottom (how far down it is), and its color.
   As time passes, the bottom gets lower and lower.
   */
  int precip_type[MAX_PRECIP_EVENTS];
  int bottom_x[MAX_PRECIP_EVENTS];
  int bottom_y[MAX_PRECIP_EVENTS];
  int  precip_color[MAX_PRECIP_EVENTS];
  int cloud_color = LT_GRAY;
  int current_precip = NONE, current_color = NONE; /*what to draw next */
  int sky_color = ICE_BLUE;

  /*Are there clouds?*/
  int current_landscape = FALSE;

  /*Is there lightning?*/
  int lightning = FALSE;
  
  /*This flag will be true if all weather should be cleared*/
  int clear_flag = FALSE;
  int i;
  int n;
  int determinant = 0; /*random integer to determine lightning*/

  /*what kind of click was there?*/
  int mouse_click;
  int points = 0;	/*number of total precip events*/
  int event; /*the most recent GP142 event*/
  int add;	/*random integer for amount of points added*/
  time_t t; /*needed only when initializing a random number generator*/

  /*
   * INITIALIZATIONS
   */

      
  srand (time(&t));	      /* Seed the random number generator             */

  GP142_open();           /* Open and init the GP142 Graphics Window      */
  GP142_logging(LOG_OFF); /* Change to LOG_ON if you want it.             */

  GP142_clear();	      /* This will clear the window & paint it white. */
  GP142_animate(ANI_RUN); /* Start animation so precips will grow         */

  DrawLandscape();
  DrawButtons(current_precip, current_color, &current_landscape); 
  ClearAllPrecipitation (precip_type, points, &current_landscape, &lightning,
							&sky_color, &points, &cloud_color);
  DrawClouds(current_landscape, cloud_color);

  /*
   * The main event loop:
   * --- ---- ----- -----
   * wait for the next user action, such as a mouse click or keyboard
   * keypress, or a periodic update event (allowing us to display the
   * next frame of an animation -- not used int this program)
   * and call the appropriate function to
   * handle it.  Repeat this until the user signals "quit".
   */
  while (!quit) {  

	/*find out what has happened */
	event = GP142_await_event(&mouse_x, &mouse_y, &key_hit);

	switch (event) {
    case GP142_QUIT:
      quit = TRUE;           /* set flag to terminate loop           */
      break;

    case GP142_KBD:
      break;

    case GP142_MOUSE:
		/* a mouse click has occurred. */
      /* check for button versus dirt */
      /* handle appropriate button click, if any */
      mouse_click = ClassifyMouseClick(mouse_x, mouse_y);
	if (mouse_click == BUTTON) {
			
		/* a button has been clicked.  Call a function to handle it*/
		handle_button(mouse_x, mouse_y, &current_precip, &current_color,
						&clear_flag, &current_landscape, &sky_color);
 
		if (clear_flag)
			ClearAllPrecipitation(precip_type, points, &current_landscape, 
									&lightning, &sky_color, &points, 
									&cloud_color);

	} else if ((mouse_click != DIRT)
		/*it's not a button, and it's not the dirt, so it must be sky*/
		&& 
		 (current_precip != NONE) && (current_color != NONE)){
		if(current_landscape == TRUE){

		points = addpoint(mouse_x, mouse_y, current_precip, 
							current_color, points, bottom_x,
							bottom_y, precip_type,
							precip_color);
		}
		
		if(points >= 100 && points < 300)
			cloud_color = MED_GRAY;
		else if(points >= 300)
			cloud_color = BLACK;
		
		if(points >= 100 && points < 300)
			sky_color = NAVY_BLUE;
		else if(points >= 300)
			sky_color = LT_GRAY;
		else if(current_landscape != NONE)
			sky_color = BLUE;
	}
		
      break;

    case GP142_PERIODIC:
      	/* make all the precipitation a little lower*/
		
		for(i = 0; i < points; i++)
		{	
		bottom_y[i] --;
		if (bottom_y[i] < (TOP_OF_DIRT - 20) ) {
			bottom_y[i] = GP142_YMAX;
			add = rand()%3;
			if(points + add <= MAX_PRECIP_EVENTS){
				for(n = points; n < points + add; n++){
					
					if(i%2 == 0)
					bottom_x[n] = bottom_x[i] + rand()%40;
					else
					bottom_x[n] = bottom_x[i] - rand()%40;

					bottom_y[n] = bottom_y[i] + (add*20*(rand()%15));
					precip_type[n] = precip_type[i];
					precip_color[n] = precip_color[i];
				}
				points = points + add;
			}
		}	
		switch (precip_type[i]){
		case 1:
			bottom_y[i] = bottom_y[i] - 2;
			break;
		case 2:
			bottom_y[i] = bottom_y[i] - 1;
			break;
		case 3:
			bottom_y[i] = bottom_y[i] - 3;
		default:
			break;
		}
		}

		/* change the sun's position*/
		sun_x --;
		if (sun_x < -GP142_XMAX -30) {
			sun_x = - sun_x;
			sun_y = sun_y -1;
				
		}

		/* find out if there is lightning */
		determinant = rand()%10;
		if(points > 350 && 4 < determinant && clear_flag == FALSE){
			lightning = TRUE;
		}else
			lightning = FALSE;

      break;

    default:

      break;
	
    }  /*end switch */

    /* Redraw everything */
	DrawLandscape(sky_color, sun_x, sun_y, current_landscape, lightning,
					 mouse_click, current_precip, current_color);
    DrawAllPrecipitation(precip_type, bottom_x, bottom_y, precip_color, points);
	DrawClouds(current_landscape, cloud_color);
	DrawButtons(current_precip, current_color, &current_landscape);
  }  /* end event loop */

  


  /*
   * WRAP-UP
   */
  GP142_close();         /* clean up and close graphics window   */

  return 0;
}  /*end main */

/*****************************************************************************

     FUNCTIONS

*****************************************************************************/


	/*reinitialize so that ALL current precipitation is erased.
	*/
  void ClearAllPrecipitation(int *precip_type, int max, int *clouds, 
								int *lightning, int *sky, int *drops,
								int *color)
  {		
	  int i = 0;
	  for(i=0; i < max; i++)
		precip_type[i] = NONE;
   *drops = 0;
   *clouds = FALSE;
   *lightning = FALSE;
   *sky = ICE_BLUE;
   *color = LT_GRAY;
}



#define RAINDROP_WIDTH 3

void DrawRainDrop (int x, int y, int color) { 
	GP142_circleXY(color, x, y, RAINDROP_WIDTH);

}

#define SNOWDROP_WIDTH 4
#define SNOWDROP_HEIGHT 5

void DrawSnowDrop (int x, int y, int color) {
	GP142_ovalXY(color, x, y, x + SNOWDROP_WIDTH, 
					y + SNOWDROP_HEIGHT, FILL);
}

#define HAILDROP_WIDTH 4

void DrawHailDrop (int x, int y, int color){
	GP142_rectangleXY(color, x, y, x + HAILDROP_WIDTH,
						y + HAILDROP_WIDTH, FILL);
}

void DrawAllPrecipitation(int *type, int *x, int *y, 
						  int *color, int n)
{	int i;
	for(i = 0; i < n; i ++){
	if (y[i] >= TOP_OF_DIRT - 20) {
		switch (type[i]) {
		case RAIN:
			DrawRainDrop (x[i], y[i], color[i]);
			break;
		case SNOW:
			DrawSnowDrop (x[i], y[i], color[i]);
			break;
		case HAIL:
			DrawHailDrop (x[i], y[i], color[i]);
			break;
		default:
			{}

		} /* end switch*/
		} /*end loop*/	
	}
}



int  ClassifyMouseClick(int mouse_x, int mouse_y)
{ 
  if ((mouse_x < -GP142_XMAX + BUTTON_WIDTH) &&
      (mouse_y < GP142_YMAX) &&
      (mouse_y > (GP142_YMAX - NUM_BUTTONS*BUTTON_HEIGHT)))
    return BUTTON;
  else if (mouse_y <= TOP_OF_DIRT)
    return DIRT;
  else
    return NONE;
}


void DrawLandscape(int current, int sun_x, int sun_y, int clouds, int lightning,
				    int click, int precip, int color)
{
	int text_offset = -GP142_XMAX + 15;
	int font_size = 12;
	int beginning_x;	/*determines the placement of the lightning*/

  /*Draw the sky first*/	
  GP142_rectangleXY(current, -GP142_XMAX, -GP142_YMAX,
		    GP142_XMAX, GP142_YMAX, FILL);

  /*Draw the sun*/
  if(clouds == FALSE)
  GP142_circleXY(YELLOW, sun_x, sun_y, 20);

  /* Draw the dirt */
  GP142_rectangleXY(BROWN, -GP142_XMAX, -GP142_YMAX,
		    GP142_XMAX, TOP_OF_DIRT, FILL);
  GP142_printfXY (BLACK, text_offset, -GP142_YMAX+30, font_size,
	  "Click a weather type and a color, then click on the picture.");

  if(precip != 0 && color != 0 && clouds == FALSE && click != BUTTON)
	  GP142_printfXY(BLACK, -GP142_XMAX + 100, -GP142_YMAX + 50, 18,
							"There must be clouds for there to be precipitation!");

  /*Draw the mountains */
  GP142_triangleXY(MED_GRAY,
		   -GP142_XMAX, TOP_OF_DIRT,
		   GP142_XMAX, TOP_OF_DIRT,
		   0, (4 * GP142_YMAX)/5 ,
		   FILL);

  GP142_triangleXY(OLIVE,
		   -( 5 * GP142_XMAX/4), TOP_OF_DIRT,
		   (GP142_XMAX)/3  , TOP_OF_DIRT,
		   -(3* GP142_XMAX)/4, (2 * GP142_YMAX)/3 ,
		   FILL);

  GP142_triangleXY(FOREST_GREEN,
		   -GP142_XMAX / 3 , TOP_OF_DIRT,
		   GP142_XMAX, TOP_OF_DIRT,
		   GP142_XMAX, (2 * GP142_YMAX)/3 ,
		   FILL);

  /*Draw the tree */
  GP142_rectangleXY(BLACK, (GP142_XMAX/8) + 20, TOP_OF_DIRT/2, 
					(GP142_XMAX/3) - 20, TOP_OF_DIRT - 20, FILL);

  GP142_triangleXY(SEA_GREEN, GP142_XMAX/8, TOP_OF_DIRT + 80, 
					GP142_XMAX/3, TOP_OF_DIRT + 80, 
					((GP142_XMAX/3) + (GP142_XMAX/8))/2, 
					(2 * GP142_YMAX)/ 6, FILL);
  
  GP142_triangleXY(SEA_GREEN, GP142_XMAX/8, TOP_OF_DIRT + 60,
					GP142_XMAX/3, TOP_OF_DIRT + 60,
					((GP142_XMAX/3) + (GP142_XMAX/8))/2,
					(2 * GP142_YMAX)/8, FILL);

  GP142_triangleXY(SEA_GREEN, GP142_XMAX/8, TOP_OF_DIRT + 40,
					GP142_XMAX/3, TOP_OF_DIRT + 40,
					((GP142_XMAX/3) + (GP142_XMAX/8))/2,
					(2 * GP142_YMAX)/ 10, FILL);
  
  /*Draw the lightning*/
  if(lightning == TRUE){
	  beginning_x = rand()%100;
  GP142_lineXY(YELLOW, beginning_x, GP142_YMAX, beginning_x + 20,
				GP142_YMAX- 80, 5);
  GP142_lineXY(YELLOW, beginning_x + 20, GP142_YMAX - 80, 
				beginning_x + 25, GP142_YMAX - 80, 5);
  GP142_lineXY(YELLOW, beginning_x + 25, GP142_YMAX - 80,
				beginning_x + 45, GP142_YMAX - 160, 5);
  GP142_lineXY(YELLOW, beginning_x + 45, GP142_YMAX - 160,
				beginning_x + 50, GP142_YMAX - 160, 5);
  GP142_lineXY(YELLOW, beginning_x + 50, GP142_YMAX - 160,
				beginning_x + 70, GP142_YMAX - 240, 5);
  GP142_lineXY(YELLOW, beginning_x + 70, GP142_YMAX - 240,
				beginning_x +75 , GP142_YMAX - 240, 5);
  GP142_lineXY(YELLOW, beginning_x + 75, GP142_YMAX - 240,
				beginning_x + 95, GP142_YMAX - 320, 5);
  }
  if(lightning == TRUE){
	  beginning_x = -rand()%100;
  GP142_lineXY(YELLOW, beginning_x, GP142_YMAX, beginning_x - 20,
				GP142_YMAX- 80, 5);
  GP142_lineXY(YELLOW, beginning_x - 20, GP142_YMAX - 80, 
				beginning_x - 25, GP142_YMAX - 80, 5);
  GP142_lineXY(YELLOW, beginning_x - 25, GP142_YMAX - 80,
				beginning_x - 45, GP142_YMAX - 160, 5);
  GP142_lineXY(YELLOW, beginning_x - 45, GP142_YMAX - 160,
				beginning_x - 50, GP142_YMAX - 160, 5);
  GP142_lineXY(YELLOW, beginning_x - 50, GP142_YMAX - 160,
				beginning_x - 70, GP142_YMAX - 240, 5);
  GP142_lineXY(YELLOW, beginning_x - 70, GP142_YMAX - 240,
				beginning_x -75 , GP142_YMAX - 240, 5);
  GP142_lineXY(YELLOW, beginning_x - 75, GP142_YMAX - 240,
				beginning_x - 95, GP142_YMAX - 320, 5);
} /*end DrawLandscape */

}
/* Figure out which button was clicked */
void handle_button(int x, int y, int *current_precip, int *current_color,
		   int *clear_weather, int *clouds, int *sky)
{
  int max_speed = 80;
  int buttonNum = 0;

  *clear_weather = FALSE; /* Assume we don't replant */

  /* If we're outside of this area, we could not have clicked on
   * a button.
   */
  if (x > -GP142_XMAX + BUTTON_WIDTH)  return;

  /* We know the mouse clicked in the column of buttons. */
  buttonNum = (GP142_YMAX - y)/BUTTON_HEIGHT;	 

  switch(buttonNum) {
  case 0:
    *current_precip = RAIN;
    break;
  case 1:
    *current_precip = SNOW;
    break;
  case 2:
	*current_precip = HAIL;
	break;

  case 3:
    *current_color = WHITE;
    break;
  case 4:
    *current_color = BLUE;
    break;
  case 5:
	*current_color = MED_GRAY;
	break;
  
  case 6:
	*clouds = TRUE;
	*sky = BLUE;
	break;
  
  case 7:
    *clear_weather = TRUE;
    break; /* Signal to clear up the weather */
  
  default:
		GP142_printfXY (RED, 50, 50, 14, "BAAADD NEWS!");
    break;
  }

}


/* Draws the buttons */
void DrawButtons(int current_precip, int current_color, int *current_landscape)
{
  int i, text_offset = -GP142_XMAX + 15, font_size = 12;

  /* draw rectangles for each button */
  for(i = 0; i < NUM_BUTTONS; i++) {
    GP142_rectangleXY(BLACK,
		      -GP142_XMAX + 4,
		      GP142_YMAX - i * BUTTON_HEIGHT - 2,
		      -GP142_XMAX + BUTTON_WIDTH,
		      GP142_YMAX - (i + 1)*BUTTON_HEIGHT - 2, 1);
  }

  /* display button text */
  /* "selected" buttons are highlighted (i.e., have a different color)*/
  i = GP142_YMAX - 25;
  if (current_precip == RAIN)
    GP142_printfXY(SELECTED_COLOR, text_offset, i, font_size, "Rain");	
  else
    GP142_printfXY(BLACK, text_offset, i, font_size, "Rain");	

  i -= BUTTON_HEIGHT;
  if (current_precip == SNOW)
    GP142_printfXY(SELECTED_COLOR, text_offset, i, font_size, "Snow");
  else
    GP142_printfXY(BLACK, text_offset, i, font_size, "Snow");
  
  i -= BUTTON_HEIGHT;
  if (current_precip == HAIL)
	GP142_printfXY(SELECTED_COLOR, text_offset, i, font_size, "Hail");
  else
	GP142_printfXY(BLACK, text_offset, i, font_size, "Hail");

 
  /* Buttons for Colors */
  i -= BUTTON_HEIGHT;
  if (current_color == WHITE)
    GP142_printfXY(SELECTED_COLOR, text_offset, i, font_size, "White");	
  else
    GP142_printfXY(BLACK, text_offset, i, font_size, "White");

  i -= BUTTON_HEIGHT;
  if (current_color == BLUE)
    GP142_printfXY(SELECTED_COLOR, text_offset, i, font_size, "Blue");
  else
    GP142_printfXY(BLACK, text_offset, i, font_size, "Blue");

  i -= BUTTON_HEIGHT;
  if (current_color == MED_GRAY)
	GP142_printfXY(SELECTED_COLOR, text_offset, i, font_size, "Gray");
  else
	GP142_printfXY(BLACK, text_offset, i, font_size, "Gray");
  
  /*Buttons for Weather */
  i -= BUTTON_HEIGHT;
  if (*current_landscape == TRUE)
	GP142_printfXY(SELECTED_COLOR, text_offset, i, font_size, "Clouds");
  else
	GP142_printfXY(BLACK, text_offset, i, font_size, "Clouds");

  i -= BUTTON_HEIGHT;
  GP142_printfXY(BLACK, text_offset, i, font_size, "Cease!");

}


void BadNewsMessage (void) {
	GP142_printfXY (RED, 0, 0, 16, "BAAAADDD NEWS!");
}


int addpoint(int x, int y, int color, int precip, int n, 
			  int bottom_x[], int bottom_y[], int precip_color[],
			  int precip_type[])
{	int i;
	i = n;
	n++;

	if(n <= MAX_PRECIP_EVENTS)
	{  bottom_x[i] = x;
	   bottom_y[i] = y;
	   precip_color[i] = color;
	   precip_type[i] = precip;
	   }
	return (n);
}
 
void DrawClouds(int clouds, int current){
				
  if(clouds == TRUE){
  GP142_ovalXY(current,-GP142_XMAX, (4*GP142_YMAX)/5, 
				-GP142_XMAX/8, GP142_YMAX, FILL);
  GP142_ovalXY(current, -GP142_XMAX/4, GP142_YMAX, GP142_XMAX/8,
				(4*GP142_YMAX)/3, FILL);
  GP142_ovalXY(current, GP142_XMAX, GP142_YMAX, GP142_XMAX/2,
				(3*GP142_YMAX)/5, FILL);
  GP142_ovalXY(current, 0, (4*GP142_YMAX)/5, GP142_XMAX/3,
				(4*GP142_YMAX)/6, FILL); 
  GP142_ovalXY(current, -GP142_XMAX/2, (3*GP142_YMAX)/4, 
				GP142_XMAX/2, GP142_YMAX, FILL);
  GP142_ovalXY(current, 0, GP142_YMAX, GP142_XMAX/2, 
				(4*GP142_YMAX)/3, FILL);
  GP142_ovalXY(current, GP142_XMAX, GP142_YMAX,
				GP142_XMAX/8, (4*GP142_YMAX)/5, FILL);
  GP142_rectangleXY(current, -GP142_XMAX, GP142_YMAX, GP142_XMAX,
					(5*GP142_YMAX)/6, FILL);
  }
}
